; GUI #
include win64a.inc
cdXPos          = 128
cdYPos          = 128
IDT_TIMER1	= 1000
WINDOWWIDTH	= 380
WINDOWHEIGHT	= 400
SmoothingModeAntiAlias = 4
UnitPixel	= 2;	
LineJoinMiter	= 0;     45.      
;   ,       
StringAlignmentFar = 2
FontStyleBold	= 1
RectF STRUCT
	Left   dd ?
	Top    dd ?
	Right  dd ?
	Bottom dd ?
RectF ENDS
PointF STRUCT
	x dd ?
	y dd ?
PointF ENDS
.code
WinMain proc 
local	msg:MSG
           
;  GDIPLUS
	invoke GdiplusStartup,&hGDIplus,&GdiPlusSI,0	
	xor ebx,ebx
	mov esi,IMAGE_BASE
	invoke	LoadCursorFromFileA,"br_Rabbit3.cur"
	mov	edi,offset ClassName
	push	rax	   ;hIconSm
	push	rdi	   ;lpszClassName
	push	rbx	   ;lpszMenuName
	push	COLOR_BTNFACE;hbrBackground
	push	rax	   ;hCursor
	push	rax       ;hIcon
	push	rsi	   ;hInstance
	push	rbx       ;cbClsExtra & cbWndExtra
	pushaddr WndProc     ;lpfnWndProc
      	mov rax,((CS_OWNDC or CS_HREDRAW or CS_VREDRAW)shl 32)+sizeof WNDCLASSEX
	push rax       ;cbSize & style
	invoke	RegisterClassExA,esp	;addr WNDCLASSEX
	push	rbx
	push	rsi	;rsi=400000h
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	cdYPos
	push	cdXPos
	sub	esp,20h
    	invoke	CreateWindowExA,0,edi,edi,WS_CAPTION or WS_SYSMENU or WS_VISIBLE
    	lea edi,msg
@@:   	invoke	GetMessageA,edi,NULL,0,0
	invoke	DispatchMessageA,edi
        jmp @b
WinMain endp
WndProc proc <12> hWnd:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT


      	mov	hWnd,rcx
      	cmp	edx,WM_DESTROY
      	je	wmDESTROY
      	cmp	edx,WM_PAINT
      	je	wmPAINT
      	cmp	edx,WM_KEYDOWN
	je	wmKEYDOWN
      	cmp	edx,WM_CREATE
	je	wmCREATE
      	cmp	edx,WM_ERASEBKGND
	je	wmERASEBKGND
        leave
        jmp NtdllDefWindowProc_

wmKEYDOWN:mov	al,r8b;wParam
	cmp	al,VK_ESCAPE;user press 'Esc'?
	jne	wmBYE

wmDESTROY:invoke GdipDeleteFont,hFont
	invoke  GdipDeleteStringFormat,hStringFormat
	invoke  GdipDeleteBrush,hBrush
	invoke  GdipDeletePen,hPen
	invoke  GdipDeleteGraphics,memGraphics
	invoke  GdipDisposeImage,hBitmap
	invoke  GdipDeleteGraphics,hGraphics
	invoke  ReleaseDC,hWnd,hDC
	mov	ecx,hGDIplus
	invoke	GdiplusShutdown
	invoke	RtlExitUserProcess,NULL
;------------------------------------------------------------
wmERASEBKGND:mov eax,TRUE
	jmp	wmBYE
wmCREATE:invoke	GetDC,hWnd
	mov	hDC,rax
	invoke	GdipCreateFromHDC,eax,&hGraphics
	invoke  GdipCreateBitmapFromGraphics,400,400,hGraphics,&hBitmap
	invoke  GdipGetImageGraphicsContext,hBitmap,&memGraphics
	invoke  GdipSetSmoothingMode,memGraphics,SmoothingModeAntiAlias
	movd	xmm1,penWidth
	invoke  GdipCreatePen1,0FFFF0000h,,UnitPixel,&hPen
	invoke  GdipSetPenLineJoin,hPen,LineJoinMiter
	invoke  GdipCreateSolidFill,0FF0000FFh,&hBrush
	invoke  GdipCreateStringFormat, NULL, NULL,&hStringFormat
	invoke  GdipSetStringFormatAlign,hStringFormat,StringAlignmentFar
	invoke  GdipSetStringFormatLineAlign,hStringFormat,StringAlignmentFar
	invoke  GdipCreateFontFamilyFromName,&szFontName,0,&hFontFamily
	movr	qword ptr[rsp+20h],hFont
	movd	xmm1,emSize
	invoke  GdipCreateFont,hFontFamily,,FontStyleBold,2
	invoke  GdipDeleteFontFamily,hFontFamily
;Set up our frames-per-second counter.
	invoke  QueryPerformanceFrequency,&perfcnt
	movq	xmm0,const1
	cvtsi2sd xmm1,perfcnt
	divsd	xmm0,xmm1
	movq	timefactor,xmm0
	invoke  QueryPerformanceCounter,&lasttime
	cvtsi2sd xmm0,lasttime
	movq	lasttime,xmm0
	jmp	wmBYE
wmPAINT:mov	eax,animation_counter
	cmp     eax,34*4
	jnb	@f
	add     eax, 4
	jmp	@0
@@:	xor	eax,eax
@0:	mov     animation_counter,eax
	lea     eax,pPoint
	add     eax,animation_counter
	mov     ecx,[rax].PointF.x
	xchg    ecx,[rax].PointF.y
	mov     [rax].PointF.x,ecx
;----------------------------------------------------------
	or	edx,-1
	invoke	GdipGraphicsClear,memGraphics
	invoke  GdipSetPenColor,hPen,0FFFF00FFh
	movd	xmm1,rectWidth
	invoke  GdipSetPenWidth,hPen
	mov	eax,myRectangle.Bottom
	mov	[rsp+28h],rax
	mov	eax,myRectangle.Right
	mov	[rsp+20h],rax
	movd	xmm3,myRectangle.Top
	movd	xmm2,myRectangle.Left
	invoke  GdipDrawRectangle,memGraphics,hPen
	invoke  GdipSetPenColor,hPen,0FF008000h
	invoke  GdipDrawCurve,memGraphics,hPen,&pPoint,18
	invoke  GdipSetPenColor,hPen,0FFFF0000h
	movd	xmm1,penWidth
	invoke  GdipSetPenWidth,hPen
	invoke  GdipDrawLines,memGraphics,hPen,&pPoint,18
	mov	eax,rect.Bottom
	mov	[rsp+28h],rax
	mov	eax,rect.Right
	mov	[rsp+20h],rax
	movd	xmm3,rect.Top
	movd	xmm2,rect.Left
	invoke  GdipDrawRectangle,memGraphics,hPen
;update FPS counter
	invoke  QueryPerformanceCounter,&curtime ;Read performance counter
	cvtsi2sd xmm0,curtime;fild    curtime
	movq	curtime,xmm0;fstp    curtime
	movq	xmm1,xmm0
	subsd	xmm0,lasttime
	mulsd	xmm0,timefactor
	movq	timespan,xmm0
	addsd	xmm0,timer
	movq	timer,xmm0
;scale time value and save : time_span=(cur_time-last_time)*time_factor
;save new time reading for next pass through the loop
	movq	lasttime,xmm1
	fninit
	fld	timer
     fld1    ;fldd    0.50
     fxch
     fcomip  st(0),st(1)
     jbe     no_fps_yet
	and	timer,0	
	movq	xmm0,const1
	divsd	xmm0,timespan
	movq	fps,xmm0
no_fps_yet:invoke sprintf,&szBuffer,"  FPS: %4.3f     ",fps
	mov	qword ptr[rsp+28h],255
	movr	qword ptr[rsp+20h],uszBuffer
	invoke  MultiByteToWideChar,CP_OEMCP,MB_PRECOMPOSED,&szBuffer, -1
	mov	rax,hBrush
	mov	[rsp+30h],rax
	mov	rax,hStringFormat
	mov	[rsp+28h],rax
	movr	qword ptr[rsp+20h],rect
	invoke  GdipDrawString,memGraphics,&uszBuffer,20,hFont
	mov	qword ptr[rsp+40h],2
	mov	eax,400
	mov	[rsp+38h],rax
	mov	[rsp+30h],rax
	xor	r8,r8
	mov	[rsp+28h],r8
	mov	[rsp+20h],r8
	invoke  GdipDrawImagePointRectI,hGraphics,hBitmap,,0
wmBYE:  leave
        ret
WndProc endp
;---------------------------------------
.data
ClassName db 'GDI+ Splines, Lines, DoubleBuffer',0
GdiPlusSI GdiplusStartupInput <1,0,0,0,0>
perfcnt	dq 0.0
  timefactor	dq 1.0 ;Time Scaling Factor
  lasttime	dq 1.0 ;Previous timer value
  curtime	dq 0   ;current timer value
  timespan	dq 1.0 ;time elapsed since last frame
  fps		dq 1.0 ;frames per second
  timer 	dq 1.0 ;accumulate timespan until one second has passed

  penWidth	    dd 0.2
  rectWidth	    dd 3.0
 const1 	    dq 1.0
  animation_counter dd 0
  emSize	    dd 14.0
  align 8
  myRectangle RectF <10.0, 10.0, 350.0, 350.0>
  rect	      RectF <10.0, 10.0, 350.0, 350.0>

  pPoint PointF <300.0, 40.0>,<100.0, 80.0>,<200.0, 120.0>,<50.0, 160.0>,<90.0, 195.726405817773>,<100.0, 113.562336350022>,
<110.0, 180.236093561674>,<120.0, 183.205669204542>,<130.0, 147.408057803263>,<140.0, 179.066485842909>,
<150.0, 296.488263212844>,<160.0, 295.763813340541>,<170.0, 330.941617453638>,<180.0, 112.155812175893>,
<190.0, 306.762179445474>,<200.0, 55.8951339964604>,<210.0, 230.641779238024>,<220.0, 17.4446966322051>
align 2
szFontName:	du <Tahoma>
.data?
szBuffer	db 128 dup(?)
uszBuffer	db 128 dup(?)
hDC		dq ?
hGDIplus	dd ?
hGraphics	dq ?
hBrush		dq ?
hPath 		dq ?
memGraphics	dq ?
hBitmap		dq ?
hPen		dq ?
hFont 		dq ?
hFontFamily	dq ?
hStringFormat	dq ?
end